product/urls.py
from django.urls import path

from product.views import IndexView, add_to_cart, remove_from_cart, AboutView, ContactView, \
    SingleProductView, ProductsView, ProductsWomenView, ProductsMenView

app_name = "product"

urlpatterns = [
    path('', IndexView.as_view(), name='index'),
    path('about/', AboutView.as_view(), name='about'),
    path('contact/', ContactView.as_view(), name='contact'),

    path('product/<uuid:uuid>', SingleProductView.as_view(), name="single-product"),
    path('products/', ProductsView.as_view(), name="all-products"),
    path('products/women/', ProductsWomenView.as_view(), name="women-products"),
    path('products/men/', ProductsMenView.as_view(), name="men-products"),

    path('add-to-cart/<uuid:uuid>', add_to_cart, name="add-to-cart"),
    path('remove-from-cart/<uuid:uuid>', remove_from_cart, name="remove-from-cart"),

]

shop/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include("product.urls")),
    path('', include("accounts.urls"))
]

urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

product/models.py
from django.db import models
from product.services.utils import generate_uuid


class BaseModel(models.Model):
    class Meta:
        abstract = True


class Product(BaseModel):
    uuid = models.UUIDField(default=generate_uuid, db_index=True, unique=True)
    product_name = models.CharField(null=False, max_length=15, unique=False)
    description = models.TextField(max_length=500, default='', blank=True)
    colour = models.CharField(null=False, max_length=20, unique=False)
    price = models.FloatField(null=False, max_length=6, unique=False)
    photo = models.ImageField(upload_to="product_photos/", null=False)

    SIZE_CHOICES = (
        ('S', 'Small'),
        ('M', 'Medium'),
        ('L', 'Large')
    )
    size = models.CharField(max_length=10, choices=SIZE_CHOICES, default='M')

    CATEGORY_CHOICES = (
        ('0', 'Men'),
        ('1', 'Women')
    )
    category = models.CharField(max_length=10, choices=CATEGORY_CHOICES)
    if category == '0':
        SUBCATEGORY_CHOICES = (
            ('sh', 'Shirts'),
            ('ts', "T-Shirts"),
            ('pa', 'Pants'),
            ('n', "None")
        )
    else:
        SUBCATEGORY_CHOICES = (
            ('sk', 'Skirts'),
            ('to', "Tops"),
            ('pa', 'Pants'),
            ("dr", "Dresses"),
            ('bl', "Blouses"),
            ('N', "None")
        )

    subcategory = models.CharField(max_length=10, choices=SUBCATEGORY_CHOICES)

    def __str__(self):
        return self.product_name

product/views.py
from datetime import timezone

from django.core.checks import messages
from django.shortcuts import get_object_or_404
from django.urls import reverse_lazy
from django.views.generic import ListView, DetailView, TemplateView
from accounts.models import OrderProduct, Order
from .models import (Product)


class IndexView(TemplateView):
    template_name = 'index.html'
    extra_context = {
            "all_products": Product.objects.all(),
            "category_w": Product.objects.filter(category="1"),
            "category_m": Product.objects.filter(category="0")
        }


class SingleProductView(DetailView):
    model = Product
    template_name = 'single-product.html'

    def get_object(self, queryset=None):
        return Product.objects.get(uuid=self.kwargs.get("uuid"))


class ProductsView(ListView):
    model = Product
    template_name = 'products.html'
    context_object_name = "all_products"


class ProductsWomenView(ProductsView):

    def get_queryset(self):
        return Product.objects.filter(category="1")


class ProductsMenView(ProductsView):

    def get_queryset(self):
        return Product.objects.filter(category="0")


class AboutView(TemplateView):
    template_name = 'about.html'


class ContactView(TemplateView):
    template_name = 'contact.html'


def add_to_cart(request, uuid):
    product = get_object_or_404(Product, uuid=uuid)
    order_product, created = OrderProduct.objects.get_or_create(
        product=product,
        user=request.user,
        ordered=False
    )
    order_qs = Order.objects.filter(user=request.user, ordered=False)

    if order_qs.exists():
        order = order_qs[0]

        if order.products.filter(product__uuid=product.uuid).exists():
            order_product.quantity += 1
            order_product.save()
            messages.Info(request, "Added quantity Product")
            return reverse_lazy("index")
        else:
            order.products.add(order_product)
            messages.Info(request, "Product added to your cart")
            return reverse_lazy("product")
    else:
        ordered_date = timezone.now()
        order = Order.objects.create(user=request.user, ordered_date=ordered_date)
        order.products.add(order_product)
        messages.Info(request, "Product added to your cart")
        return reverse_lazy("product")


def remove_from_cart(request, uuid):
    product = get_object_or_404(Product, uuid=uuid)
    order_qs = Order.objects.filter(
        user=request.user,
        ordered=False
    )
    if order_qs.exists():
        order = order_qs[0]
        if order.products.filter(product__uuid=product.uuid).exists():
            order_product = OrderProduct.objects.filter(
                product=product,
                user=request.user,
                ordered=False
            )[0]
            order_product.delete()
            messages.Info(request, "Product \""+order_product.product.product_name+"\" remove from your cart")
            return reverse_lazy("product", uuid=uuid)
        else:
            messages.Info(request, "This Product not in your cart")
            return reverse_lazy("product", uuid=uuid)
    else:
        messages.Info(request, "You do not have an Order")
        return reverse_lazy("product", uuid=uuid)

product/templates/about.html
<!DOCTYPE html>
{% load static %}
<html lang="en">

  <head>

    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="description" content="">
    <meta name="author" content="">
    <link href="https://fonts.googleapis.com/css?family=Poppins:100,200,300,400,500,600,700,800,900&display=swap" rel="stylesheet">

    <title>About Page</title>


    <!-- Additional CSS Files -->
    <link rel="stylesheet" href="{% static 'css/bootstrap.min.css' %}" type="text/css">

    <link rel="stylesheet" href="{% static 'css/font-awesome.css'%}" type="text/css">

    <link rel="stylesheet" href="{% static 'css/templatemo-hexashop.css'%}" type="text/css">

    <link rel="stylesheet" href="{% static 'css/owl-carousel.css'%}" type="text/css">

    <link rel="stylesheet" href="{% static 'css/lightbox.css'%}" type="text/css">
<!--

TemplateMo 571 Hexashop

https://templatemo.com/tm-571-hexashop

-->
    </head>
    
    <body>
    
    <!-- ***** Preloader Start ***** -->
    <div id="preloader">
        <div class="jumper">
            <div></div>
            <div></div>
            <div></div>
        </div>
    </div>  
    <!-- ***** Preloader End ***** -->
    
    
    <!-- ***** Header Area Start ***** -->
    <header class="header-area header-sticky">
        <div class="container">
            <div class="row">
                <div class="col-12">
                    <nav class="main-nav">
                        <!-- ***** Logo Start ***** -->
                        <a href="{% url 'product:index' %}" class="logo">
                            <img src="{% static 'images/logo.png'%}">
                        </a>
<!-- ***** Logo End ***** -->
<!-- ***** Menu Start ***** -->
                        <ul class="nav">
                            <li class="scroll-to-section"><a href="{% url 'product:index' %}" class="active">Home</a></li>
                            <li class="scroll-to-section"><a href="{% url 'product:men-products' %}">Men's</a></li>
                            <li class="scroll-to-section"><a href="{% url 'product:women-products' %}">Women's</a></li>
                            <li class="submenu">
                                <a href="javascript:;">More info</a>
                                <ul>
                                    <li><a href="{% url 'product:about' %}">About Us</a></li>
                                    <li><a href="{% url 'product:contact' %}">Contact Us</a></li>
                                </ul>
                            </li>
                        </ul>
                        <a class='menu-trigger'>
                            <span>Menu</span>
                        </a>
<!-- ***** Menu End ***** -->
                    </nav>
                </div>
            </div>
        </div>
    </header>
    <!-- ***** Header Area End ***** -->

    <!-- ***** Main Banner Area Start ***** -->
    <div class="page-heading about-page-heading" id="top">
        <div class="container">
            <div class="row">
                <div class="col-lg-12">
                    <div class="inner-content">
                        <h2>About Our Company</h2>
                        <span>Awesome &amp; creative Online-shop</span>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- ***** Main Banner Area End ***** -->

    <!-- ***** About Area Starts ***** -->
    <div class="about-us">
        <div class="container">
            <div class="row">
                <div class="col-lg-6">
                    <div class="left-image">
                        <img src="{% static 'images/about-left-image.jpg'%}">
                    </div>
                </div>
                <div class="col-lg-6">
                    <div class="right-content">
                        <h4>About Us &amp; Our Skills</h4>
                        <span>We have been on the market for over five years. Our difference is quality, availability and stability</span>
                        <div class="quote">
                            <i class="fa fa-quote-left"></i><p>HexaShop conquers the Ukrainian market of both women's and men's clothing</p>
                        </div>
                        <p>- it's what Ukrainian Vogue writes about us in the March 2021 issue of the article about outstanding business</p>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- ***** About Area Ends ***** -->

    <!-- ***** Services Area Starts ***** -->
    <section class="our-services">
        <div class="container">
            <div class="row">
                <div class="col-lg-12">
                    <div class="section-heading">
                        <h2>Our Services</h2>
                        <span>What makes Hexashop different from the other teams?</span>
                    </div>
                </div>
                <div class="col-lg-4">
                    <div class="service-item">
                        <h4>Spacious shops</h4>
                        <p>Our stores are located in Odessa, Kiev, Kharkov, Dnepropetrovsk, Kherson, Lvov. Follow us, because there is more to come!</p>
                        <img src="{% static 'images/service-01.jpg'%}">
                    </div>
                </div>
                <div class="col-lg-4">
                    <div class="service-item">
                        <h4>Wide choice</h4>
                        <p>In our stores you will definitely find what you are looking for, because we have a huge selection of clothes for both women and men.</p>
                        <img src="{% static 'images/service-02.jpg'%}">
                    </div>
                </div>
                <div class="col-lg-4">
                    <div class="service-item">
                        <h4>Individual approach</h4>
                        <p>Even with a large number of clients, we devote time to everyone, because our goal is happy clients</p>
                        <img src="{% static 'images/service-03.jpg'%}">
                    </div>
                </div>
            </div>
        </div>
    </section>
    <!-- ***** Services Area Ends ***** -->

    <!-- ***** Footer Start ***** -->
    <footer>
        <div class="container">
            <div class="row">
                <div class="col-lg-3">
                    <div class="first-item">
                        <div class="logo">
                            <img src="/static/images/white-logo.png" alt="hexashop ecommerce templatemo">
                        </div>
                        <ul>
                            <li>street Deribasivska, 21, Odessa, Odessa region, 65000</li>
                            <li>hexashop@company.com</a></li>
                            <li>010-020-034</li>
                        </ul>
                    </div>
                </div>
                <div class="col-lg-3">
                    <h4>Shopping &amp; Categories</h4>
                    <ul>
                        <li><a  href="{% url 'product:men-products' %}">Men’s Shopping</a></li>
                        <li><a  href="{% url 'product:women-products' %}">Women’s Shopping</a></li>
\                    </ul>
                </div>
                <div class="col-lg-3">
                    <h4>Useful Links</h4>
                    <ul>
                        <li><a href="{% url 'product:index' %}">Homepage</a></li>
                        <li><a href="{% url 'product:about' %}">About Us</a></li>
                        <li><a href="{% url 'product:contact' %}">Contact Us</a></li>
                    </ul>
                </div>
                <div class="col-lg-12">
                    <div class="under-footer">
                        <p>Made by: Olga K for Hillel</p>
                    </div>
                </div>
            </div>
        </div>
    </footer>
    

    <!-- jQuery -->
    <script src="{% static 'js/jquery-2.1.0.min.js'%}"></script>

    <!-- Bootstrap -->
    <script src="{% static 'js/popper.js'%}"></script>
    <script src="{% static 'js/bootstrap.min.js'%}"></script>

    <!-- Plugins -->
    <script src="{% static 'js/owl-carousel.js'%}"></script>
    <script src="{% static 'js/accordions.js'%}"></script>
    <script src="{% static 'js/datepicker.js'%}"></script>
    <script src="{% static 'js/scrollreveal.min.js'%}"></script>
    <script src="{% static 'js/waypoints.min.js'%}"></script>
    <script src="{% static 'js/jquery.counterup.min.js'%}"></script>
    <script src="{% static 'js/imgfix.min.js'%}"></script>
    <script src="{% static 'js/slick.js'%}"></script>
    <script src="{% static 'js/lightbox.js'%}"></script>
    <script src="{% static 'js/isotope.js'%}"></script>

    <!-- Global Init -->
    <script src="{% static 'js/custom.js'%}"></script>

    <script>

        $(function() {
            var selectedClass = "";
            $("p").click(function(){
            selectedClass = $(this).attr("data-rel");
            $("#portfolio").fadeTo(50, 0.1);
                $("#portfolio div").not("."+selectedClass).fadeOut();
            setTimeout(function() {
              $("."+selectedClass).fadeIn();
              $("#portfolio").fadeTo(50, 1);
            }, 500);
                
            });
        });

    </script>

  </body>

</html>

product/templates/index.html
<!DOCTYPE html>
{% load static %}
<html lang="en">

  <head>

    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="description" content="">
    <meta name="author" content="">
    <link href="https://fonts.googleapis.com/css?family=Poppins:100,200,300,400,500,600,700,800,900&display=swap" rel="stylesheet">

    <title>Hexashop Ecommerce HTML CSS Template</title>


    <!-- Additional CSS Files -->
    <link rel="stylesheet" href="{% static 'css/bootstrap.min.css' %}" type="text/css">

    <link rel="stylesheet" href="{% static 'css/font-awesome.css'%}" type="text/css">

    <link rel="stylesheet" href="{% static 'css/templatemo-hexashop.css'%}" type="text/css">

    <link rel="stylesheet" href="{% static 'css/owl-carousel.css'%}" type="text/css">

    <link rel="stylesheet" href="{% static 'css/lightbox.css'%}" type="text/css">
<!--

TemplateMo 571 Hexashop

https://templatemo.com/tm-571-hexashop

-->
    </head>
    
    <body>
    
    <!-- ***** Preloader Start ***** -->
    <div id="preloader">
        <div class="jumper">
            <div></div>
            <div></div>
            <div></div>
        </div>
    </div>  
    <!-- ***** Preloader End ***** -->
    
    
<!-- ***** Header Area Start ***** -->
    <header class="header-area header-sticky">
        <div class="container">
            <div class="row">
                <div class="col-12">
                    <nav class="main-nav">
                        <!-- ***** Logo Start ***** -->
                        <a href="{% url 'product:index' %}" class="logo">
                            <img src="static/images/logo.png">
                        </a>
<!-- ***** Logo End ***** -->
<!-- ***** Menu Start ***** -->
                        <ul class="nav">
                            <li class="scroll-to-section"><a href="{% url 'product:index' %}" class="active">Home</a></li>
                            <li class="scroll-to-section"><a href="{% url 'product:men-products' %}">Men's</a></li>
                            <li class="scroll-to-section"><a href="{% url 'product:women-products' %}">Women's</a></li>
                            <li class="submenu">
                                <a href="javascript:;">More info</a>
                                <ul>
                                    <li><a href="{% url 'product:about' %}">About Us</a></li>
                                    <li><a href="{% url 'product:contact' %}">Contact Us</a></li>
                                </ul>
                            </li>
                        </ul>        
                        <a class='menu-trigger'>
                            <span>Menu</span>
                        </a>
<!-- ***** Menu End ***** -->
                    </nav>
                </div>
            </div>
        </div>
    </header>
<!-- ***** Header Area End ***** -->

{% block content %}
<!-- ***** Main Banner Area Start ***** -->
    <div class="main-banner" id="top">
        <div class="container-fluid">
            <div class="row">
                <div class="col-lg-6">
                    <div class="left-content">
                        <div class="thumb">
                            <div class="inner-content">
                                <h4>We Are Hexashop</h4>
                                <span>Awesome &amp; creative Online-shop</span>
                                <div class="main-border-button">
                                    <a href="{% url 'product:all-products' %}">Purchase Now!</a>
                                </div>
                            </div>
                            <img src="static/images/left-banner-image.jpg" alt="">
                        </div>
                    </div>
                </div>
                <div class="col-lg-6">
                    <div class="right-content">
                        <div class="row">
                            <div class="col-lg-6">
                                <div class="right-first-image">
                                    <div class="thumb">
                                        <div class="inner-content">
                                            <h4>Women</h4>
                                            <span>Best Clothes For Women</span>
                                        </div>
                                        <div class="hover-content">
                                            <div class="inner">
                                                <h4>Women</h4>
                                                <p> Be stylish and cool with Hexa-clothes</p>
                                                <div class="main-border-button">
                                                    <a href="{% url 'product:women-products' %}">Discover More</a>
                                                </div>
                                            </div>
                                        </div>
                                        <img src="static/images/baner-right-image-01.jpg">
                                    </div>
                                </div>
                            </div>
                            <div class="col-lg-6">
                            </div>
                            <div class="col-lg-6">
                            </div>
                            <div class="col-lg-6">
                                <div class="right-first-image">
                                    <div class="thumb">
                                        <div class="inner-content">
                                            <h4>Men</h4>
                                            <span>Best Clothes For Men</span>
                                        </div>
                                        <div class="hover-content">
                                            <div class="inner">
                                                <h4>Men</h4>
                                                <p>Only best of the best for stylish men.</p>
                                                <div class="main-border-button">
                                                    <a  href="{% url 'product:men-products' %}">Discover More</a>
                                                </div>
                                            </div>
                                        </div>
                                        <img src="static/images/baner-right-image-02.jpg">
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
<!-- ***** Main Banner Area End ***** -->

<!-- ***** Women Area Starts ***** -->
    <section class="section" id="women">
        <div class="container">
            <div class="row">
                <div class="col-lg-6">
                    <div class="section-heading">
                        <h2>Women's Latest</h2>
                        <span>Our newest items for women</span>
                    </div>
                </div>
            </div>
        </div>
        <div class="container">
            <div class="row">
                <div class="col-lg-12">
                    <div class="women-item-carousel">
                        <div class="owl-women-item owl-carousel">
                            {% for product in category_w %}
                            <div class="item">
                                <div class="thumb">
                                    <div class="hover-content">
                                        <ul>
                                            <li><a href="/product/{{product.uuid}}"><i class="fa fa-eye"></i></a></li>
                                        </ul>
                                    </div>
                                    <img src="media/{{ product.photo }}" width="390" height="520">
                                </div>
                                <div class="down-content">
                                    <h4>{{ product.product_name }}</h4>
                                    <span>{{ product.price }}</span>
                                </div>
                            </div>
                            {% endfor %}
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>
<!-- ***** Women Area Ends ***** -->

<!-- ***** Men Area Starts ***** -->
    <section class="section" id="men">
        <div class="container">
            <div class="row">
                <div class="col-lg-6">
                    <div class="section-heading">
                        <h2>Men's Latest</h2>
                        <span>Our newest items for men</span>
                    </div>
                </div>
            </div>
        </div>
        <div class="container">
            <div class="row">
                <div class="col-lg-12">
                    <div class="men-item-carousel">
                        <div class="owl-men-item owl-carousel">
                            {% for product in category_m %}
                            <div class="item">
                                <div class="thumb">
                                    <div class="hover-content">
                                        <ul>
                                            <li><a href="/product/{{product.uuid}}"><i class="fa fa-eye"></i></a></li>
                                        </ul>
                                    </div>
                                    <img src="media/{{ product.photo }}" width="390" height="520">
                                </div>
                                <div class="down-content">
                                    <h4>{{ product.product_name }}</h4>
                                    <span>{{ product.price }}</span>
                                </div>
                            </div>
                            {% endfor %}
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>
<!-- ***** Men Area Ends ***** -->



    <!-- ***** Footer Start ***** -->
    <footer>
        <div class="container">
            <div class="row">
                <div class="col-lg-3">
                    <div class="first-item">
                        <div class="logo">
                            <img src="static/images/white-logo.png" alt="hexashop ecommerce templatemo">
                        </div>
                        <ul>
                            <li>street Deribasivska, 21, Odessa, Odessa region, 65000</li>
                            <li>hexashop@company.com</a></li>
                            <li>010-020-034</li>
                        </ul>
                    </div>
                </div>
                <div class="col-lg-3">
                    <h4>Shopping &amp; Categories</h4>
                    <ul>
                        <li><a  href="{% url 'product:men-products' %}">Men’s Shopping</a></li>
                        <li><a  href="{% url 'product:women-products' %}">Women’s Shopping</a></li>
\                    </ul>
                </div>
                <div class="col-lg-3">
                    <h4>Useful Links</h4>
                    <ul>
                        <li><a href="{% url 'product:index' %}">Homepage</a></li>
                        <li><a href="{% url 'product:about' %}">About Us</a></li>
                        <li><a href="{% url 'product:contact' %}">Contact Us</a></li>
                    </ul>
                </div>
                <div class="col-lg-12">
                    <div class="under-footer">
                        <p>Made by: Olga K for Hillel</p>
                    </div>
                </div>
            </div>
        </div>
    </footer>
    

    <!-- jQuery -->
    <script src="static/js/jquery-2.1.0.min.js"></script>

    <!-- Bootstrap -->
    <script src="static/js/popper.js"></script>
    <script src="static/js/bootstrap.min.js"></script>

    <!-- Plugins -->
    <script src="static/js/owl-carousel.js"></script>
    <script src="static/js/accordions.js"></script>
    <script src="static/js/datepicker.js"></script>
    <script src="static/js/scrollreveal.min.js"></script>
    <script src="static/js/waypoints.min.js"></script>
    <script src="static/js/jquery.counterup.min.js"></script>
    <script src="static/js/imgfix.min.js"></script>
    <script src="static/js/slick.js"></script>
    <script src="static/js/lightbox.js"></script>
    <script src="static/js/isotope.js"></script>
    
    <!-- Global Init -->
    <script src="static/js/custom.js"></script>

    <script>

        $(function() {
            var selectedClass = "";
            $("p").click(function(){
            selectedClass = $(this).attr("data-rel");
            $("#portfolio").fadeTo(50, 0.1);
                $("#portfolio div").not("."+selectedClass).fadeOut();
            setTimeout(function() {
              $("."+selectedClass).fadeIn();
              $("#portfolio").fadeTo(50, 1);
            }, 500);
                
            });
        });

    </script>

  </body>
</html>

{% endblock %}